function [u, v, vs, Bellman_error] = policy_evaluation(mdp, policy, niters)

%% input: 
%%   mdp
%%   policy
%%   niters: number of iterations used for the evaluation
%%
%% output:
%%   u: utility of the policy
%%   v: value function for the policy
%%   vs: value function throughout iterations
%%   Bellman_error: maximum Bellman error, and mean Bellman error throughout iterations
%%

% allocate all the memory (not required by matlab, but it makes it faster
% typically)
v = zeros(mdp.nS,1); 
v_new = zeros(mdp.nS,1);
q = zeros(mdp.nS, mdp.nA);
Bellman_error = zeros(niters,2);
vs = zeros(niters, mdp.nS);

% run the policy evaluation
for vi_iter = 1:niters
	%	vi_iter
	for s=1:mdp.nS
		a = %%% your code here %%%
		v_new(s) = %%% your code here %%%
	end
	Bellman_error(vi_iter,1) = max(abs(v_new - v));
	Bellman_error(vi_iter,2) = mean(abs(v_new-v));
	v = v_new;
	vs(vi_iter,:) = v';
end

u = v'*mdp.d;
