addpath grid_mdps

vi_flag = 1;
pi_flag = 0;
q_flag = 1;


%% RL

%% construct the MDP:

n = 5; 
p_fail = .01; %% probability of not following the desired state-action transition
discount = .9;

goalstates = [1]; w = [1];
grid_mdp =  construct_grid_mdp_no_reward(n, p_fail, discount);
[grid_mdp.r, grid_mdp.F, grid_mdp.nF, grid_mdp.w] = construct_goal_feature_reward_for_grid_mdp(grid_mdp, goalstates, w);

% horizon H
H = 10*ceil(1/(1-grid_mdp.gamma));

%% policy iteration

for s=1:grid_mdp.nS
	policy(s) = 1; % init with action that makes agent stay in place
end

n_policy_eval_iters = 5; % run with 1, 5, 10
p_iters = 30;  

U_pi = [];
for k=1:p_iters
	% evaluate the current policy for plotting purposes: (we use H
	% iterations here, rather than n_policy_eval_iters, b/c this is not
	% part of the algorithm, it's just part of the evaluation, and the
	% evaluation should be accurate)
	U_pi(k) = policy_evaluation(grid_mdp, policy, H);

	% policy evaluation step
	[foo, v] = policy_evaluation(grid_mdp, policy, n_policy_eval_iters);
	% policy update step
	policy = greedy_policy(grid_mdp, v);
end
grid_visualize_policy_and_cost(n, policy, grid_mdp.r);
% plot learning curve:
figure; plot((1:p_iters)*n_policy_eval_iters, U_pi);
