addpath grid_mdps

%% construct the MDP:

n = 5; 
p_fail = .01; %% probability of not following the desired state-action transition
discount = .9;

goalstates = [1]; w = [1];
grid_mdp =  construct_grid_mdp_no_reward(n, p_fail, discount);
[grid_mdp.r, grid_mdp.F, grid_mdp.nF, grid_mdp.w] = construct_goal_feature_reward_for_grid_mdp(grid_mdp, goalstates, w);

% evaluation horizon H
H = 10*ceil(1/(1-grid_mdp.gamma));



%% Q learning

Q = zeros(grid_mdp.nS, grid_mdp.nA);
U_Q = [];
n_steps_Q = [];
a_log = [];
epsilon_not_greedy = .2;

T = 1e5;
s = zeros(1e6,1);
s(1) = 10;

% at time t, choose learning rate alpha = 100/(100+t)

for t=1:T

	if(rand < epsilon_not_greedy)
		% pick action uniformly at random
		a = sample_from_density(ones(1,grid_mdp.nA)/grid_mdp.nA);
	else
		% pick greedy action
		%%% your code here %%%
	end

	% execute action and q-learning update:
	
	%%% your code here %%%

	
	
	% let's compute utility of the policy we found so far
	if(mod(t,10000) == 1)
		t
		for tmp_s=1:grid_mdp.nS
			[foo, policy(tmp_s)] = max(Q(tmp_s,:));
		end
		U_Q = [U_Q policy_evaluation(grid_mdp, policy, H)];
		n_steps_Q = [n_steps_Q t];
		grid_visualize_policy_and_cost(n, policy, grid_mdp.r);
	end
end

figure; plot(n_steps_Q, U_Q);



