addpath grid_mdps

%% RL

%% construct the MDP:

n = 5; 
p_fail = .01; %% probability of not following the desired state-action transition
discount = .9;

goalstates = [1]; w = [1];
grid_mdp =  construct_grid_mdp_no_reward(n, p_fail, discount);
[grid_mdp.r, grid_mdp.F, grid_mdp.nF, grid_mdp.w] = construct_goal_feature_reward_for_grid_mdp(grid_mdp, goalstates, w);

% horizon H
H = 10*ceil(1/(1-grid_mdp.gamma));


%% value iteration

iter_increment = 1;
n_increments = 20;

U_vi = [];
initV = zeros(grid_mdp.nS,1);
for k=1:n_increments
	[policy, q, v, vs, Bellman_error] = value_iteration_GS(grid_mdp, iter_increment, initV);
	%	grid_visualize_policy_and_cost(n, policy, grid_mdp.r);
	U_vi(k) = policy_evaluation(grid_mdp, policy, H);
	initV = v;
end
grid_visualize_policy_and_cost(n, policy, grid_mdp.r);
% plot learning curve:
figure; plot((1:n_increments)*iter_increment, U_vi);



